.386
.model flat,stdcall
option casemap:none

include	\masm32\include\windows.inc
include 	\masm32\include\user32.inc
include 	\masm32\include\kernel32.inc
include 	\masm32\include\gdi32.inc
include 	\masm32\include\ole32.inc
include 	\masm32\include\masm32.inc
include	fish.inc

includelib	\masm32\lib\user32.lib
includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\gdi32.lib
includelib	\masm32\lib\ole32.lib
includelib	\masm32\lib\oleaut32.lib

DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
DlgName db 'DlgBox',0

.data?
hBitmap	dd ?


.code
start:
	invoke GetModuleHandle, NULL
	invoke DialogBoxParam, eax,1000,NULL,addr DlgProc,NULL
	invoke ExitProcess,eax

DlgProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

   LOCAL ps:PAINTSTRUCT
   LOCAL hdc:HDC
   LOCAL hMemDC:HDC

	.IF uMsg==WM_INITDIALOG

		invoke	CoInitialize, NULL
		invoke	BitmapFromMemory,ADDR pImage,ln_pImage
		mov	hBitmap,eax

	.ELSEIF uMsg==WM_PAINT
	
		invoke	BeginPaint,hWnd,ADDR ps
		mov	hdc,eax
		invoke	CreateCompatibleDC,eax
		mov	hMemDC,eax
		invoke	SelectObject,eax,hBitmap
		invoke	BitBlt,hdc,0,0,102,100,hMemDC,0,0,SRCCOPY
		invoke	DeleteDC,hMemDC
		invoke	EndPaint,hWnd,ADDR ps

	.ELSEIF uMsg==WM_CLOSE

		invoke	DeleteObject,hBitmap
		invoke	CoUninitialize
		invoke	EndDialog, hWnd,NULL

	.ELSE
		mov eax,FALSE
		ret
	.ENDIF
	mov eax,TRUE
	ret

DlgProc ENDP

END start
